# CBpanel "PAGER" plugin

name = "Pager"
description = "Draw a pager on the panel"

import CBpanel, gtk, gtk.gdk, wnck

class Plugin(CBpanel.Plugin):
    def __init__(self, panel, settings):
        CBpanel.Plugin.__init__(self, panel, settings)
        self.set_border_width(0)
        self.screen = wnck.screen_get_default()
        self.screen.connect("workspace-created", lambda s,w: self.resize())
        self.screen.connect("workspace-destroyed", lambda s,w: self.resize())
        self.pager = wnck.Pager(self.screen)
        #rect = gtk.gdk.Rectangle(0, 0, 10, 25)
        #pager.size_allocate(rect)
        #        al = gtk.Alignment(0.5, 0.5, 0, 0)
        #        al.show()
        self.connect("scroll-event", self.__cb_scroll)
        #        self.add(al)
        #        al.add(self.pager)
        self.add(self.pager)
        self.resize()
        self.show_all()

    def resize(self):
        ws = self.screen.get_workspace_count()
        #pw, ph = self.panel.get_size()
        height = 24
        width = ws * 32
        rows = 1
        self.pager.set_size_request(width, height)
        #print "size request is %d x %d" % (width, height)
        self.pager.set_n_rows(rows)

    def __cb_scroll(self, widget, event):

        ws = self.screen.get_active_workspace()
        n = ws.get_number()
        wc = self.screen.get_workspace_count()

        if event.direction == gtk.gdk.SCROLL_UP:
            d = max(0, n-1)
        elif event.direction == gtk.gdk.SCROLL_DOWN:
            d = min(wc-1, n+1)

        new = self.screen.get_workspace(d)
        new.activate(event.time)



